Subject: Re: [PATCH net 1/2] ipv6: Dump route exceptions too in rt6_dump_route()

From: David Ahern <[email-masked]>
Date: Thu, 6 Jun 2019 16:47:00 -0600

On 6/6/19 3:18 PM, Stefano Brivio wrote:
> On Thu, 6 Jun 2019 14:57:33 -0600
> David Ahern <[email-masked]> wrote:
> 
>>> This will cause a non-trivial conflict with commit cc5c073a693f
>>> ("ipv6: Move exception bucket to fib6_nh") on net-next. I can submit
>>> an equivalent patch against net-next, if it helps.
>>>   
>>
>> Thanks for doing this. It is on my to-do list.
>>
>> Can you do the same for IPv4?
> 
> You mean this same fix? On IPv4, for flushing, iproute2
> uses /proc/sys/net/ipv4/route/flush in iproute_flush_cache(), and that
> works.
> 
> Listing doesn't work instead, for some different reason I haven't
> looked into yet. That doesn't look as critical as the situation on IPv6
> where one can't even flush the cache: exceptions can also be fetched
> with 'ip route get', and that works.
> 
> Still, it's bad, I can look into it within a few days.
> 

I meant the ability to dump the exception cache.

Currently, we do not get the exceptions in a fib dump. There is a flag
to only show cloned (cached) entries, but no way to say 'no cloned
entries'. Maybe these should only be dumped if the cloned flag is set.
That's the use case I was targeting:
1. fib dumps - RTM_F_CLONED not set
2. exception dump - RTM_F_CLONED set